



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java-从Double类型精度丢失认识BigDecimal</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java-从Double类型精度丢失认识BigDecimal</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 07:44:40 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>Java-从Double类型精度丢失认识BigDecimal</h2>
<h3>参考资料</h3>
<ul><li><a href="https://www.jianshu.com/p/07e3eeb90f18" rel="external nofollow noreferrer">https://www.jianshu.com/p/07e3eeb90f18</a></li>
<li><a href="https://zh.wikipedia.org/wiki/IEEE_754" rel="external nofollow noreferrer">https://zh.wikipedia.org/wiki/IEEE_754</a></li>
<li><a href="https://docs.oracle.com/javase/7/docs/api/java/math/BigDecimal.html" rel="external nofollow noreferrer">https://docs.oracle.com/javase/7/docs/api/java/math/BigDecimal.html</a></li></ul>
<h3>Double类型丢失精度</h3>
<pre class="prettyprint linenums"><code>public static void main(String[] args) {<br />
    double value = 0.05 + 0.01;<br />
    System.out.println(value);<br />
    //0.060000000000000005<br />
}<br />
</code></pre>
<p>double 类型的 0.05 + 0.01 的结果我们猜想的应该是 <code>0.06</code> 但是程序的数据结果却是大大的超出了我们的预料(我们称这种现象为<code>精度丢失</code>)，造成上面的这种情况的原因是小数在计算机中的存储形式造成的。</p>
<p>精度丢失的原因不是本篇博客的主要内容，所以在这里不再赘述，想要了解的可以查看，文章顶部的 IEEE 754 的规范。</p>
<p>double 类型存在着上面的这种问题，所以我们肯定是不能用它来进行特别精细的计算了，比如 <code>科学研究</code> 和 <code>金融</code>  相关的业务逻辑。因为一旦数据不精确就可能造成比较严重的问题。</p>
<h3>BigDecimal</h3>
<p>既然出现了上面的这种问题，肯定是有解决办法的，官方提供的解决办法就是 <code>BigDecimal</code> 类。</p>
<p>与BigDecimal类似的还有<code>BigInteger</code>类.</p>
<h4>构造BitDecimal</h4>
<p><img referrerpolicy="no-referrer"src="http://cdn.shycoder.cn/Snag_b0edd2.png"></p>
<p>具有char[]参数的构造方法我们一般是不会去主动调用的，因为当我们调用具有string参数的构造函数时，会间接地调用char[]参数的构造方法。</p>
<pre class="prettyprint linenums"><code>public BigDecimal(String val) {<br />
    this(val.toCharArray(), 0, val.length());<br />
}<br />
</code></pre>
<p>在构建BigDecimal的时候推荐使用String参数的构造方法，因为double参数的构造方法会会出现一些问题。</p>
<pre class="prettyprint linenums"><code>public static void main(String[] args) {<br />
    BigDecimal bigDecimal = new BigDecimal(0.06);<br />
    System.out.println(bigDecimal);

    BigDecimal bigDecimalStr = new BigDecimal(&quot;0.06&quot;);<br />
    System.out.println(bigDecimalStr);<br />
}<br />
</code></pre>
<p>输出结果如下</p>
<pre class="prettyprint linenums"><code>0.059999999999999997779553950749686919152736663818359375<br />
0.06<br />
</code></pre>
<p>通过输出结果我们发现,当通过double参数的构造方法的来创建BigDecimal对象的时候，输出结果更加的让人头大了 												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/8z1kx5d9.html">安装SRILM</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yd6peq.html">HDU 5742 It&amp;&num;39&semi;s All In The Mind （贪心）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj17veq.html">Static 单例模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk4wod8.html">Spring Cloud Ribbon 整合 Hystrix</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo7j5xq.html">Luogu P1919 【模板】A&ast;B Problem升级版（FFT快速傅里叶&lowbar;FFT</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj0rx19.html">Cocos2D在Xcode7和iOS 9&period;2上IMP调用出错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwwerj9.html">PageHelper分页&plus;前台BootStrap&lowbar;pagination样式&sol;BootStrap&lowbar;table样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9607kwv9.html">【刷题记录】BZOJ-USACO</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g7g0eq.html">JavaScript&colon; For &comma; For&sol;in &comma; For&sol;of</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv23zoo9.html">中间件RabbitMQ之运维篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdxd209.html">arcgis&lowbar;js&lowbar;api&lowbar;3&period;12的project实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gvvn6q.html">caffe添加自己编写的Python层</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25n4rvq.html">Buffer学习笔记&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2p2jy9.html">SQL基本练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w0lwrq.html">Maven构建的Spring项目需要哪些依赖？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvw1r2q.html">张高兴的 &period;NET Core IoT 入门指南：（二）GPIO 的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko0dj6q.html">&lbrack;LCT应用&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm2kze9.html">Storm 系列（三）Storm 集群部署和配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pk2pw8.html">ios的一些知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2rvjv8.html">&lbrack;Jobdu&rsqb; 题目1530：最长不重复子串</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4jnd5nq.html">hishlib 算法加密</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4o3wx9.html">【linux】centos6&period;9通过virtualenv安装python3&period;5</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1pvr09.html">NMT 机器翻译</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2prroq.html">hdu2196 树形dp经典&vert;树的直径</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj5dn39.html">python字符编码和文件处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4o71e9.html">sublime快捷键的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwo36z9.html">小米8如何root</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gjljzq.html">asp&period;net core 缓存和Session</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwo1kv9.html">网络安全：robots&period;txt防止向黑客泄露后台地址和隐私目录的写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdem2d9.html">TURN TAP&colon; Temporal Unit Regression Network for Temporal Action Proposals（ICCV2017）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
